/*----------------------------------------------------------------------------
/	SCI}N`										2006 (C) LOGIC PACK
/-----------------------------------------------------------------------------
/	Version		Date							Name
/	000			03.								M.Yamada
/	001			06.11.24						K.Suzuki
/			H8300HH8_Tinyʉ	
/	002			07.03.03						M.Yamada
/			E[H8/3687]INT_TXI()TDRENAƑMf[^Ȃ
/			dďo͂Ă܂̂ō폜
/			(H8Tiny͎NAA3069͎蓮NA)
/			EłɎMtORDRFl
/	003			07.07.11						M.Yamada
/			EG[̃NAYC
/	004			07.08.03						K.Suzuki
/			sciX_txempty()	Xy~XC(Sӏ)
/			SCI_TXEMPTY()	SɑMIɕύX
/	005			07.10.18						M.Yamada
/			SCI_TXTRG() f[^]ɑMĂ܂
/			sC
/	006			07.12.21						M.Yamada
/---------------------------------------------------------------------------*/
#include <machine.h>												//ADD 002
#include "iodefine.h"
#include "sci.h"

/*-----------------------------------------------
/ *DEFINE
/----------------------------------------------*/
//#if ( CPU_TYPE == H8_3069 )										//MOD 006
#if ( CPU_TYPE == H8_3069 ) || ( CPU_TYPE == SH2 )
	#define SCRn	SCR
	#define OERx	ORER	
#elif ( CPU_TYPE == H8_3664 ) 
	#define SCRn	SCR3
	#define OERx	OER	
#endif

/* 荞ݐ */													//ADD 006
#if ( CPU_TYPE == H8_3069 ) || ( CPU_TYPE == H8_3664 )
#define INTR_DISABLE()		set_imask_ccr(1)
#define INTR_ENABLE()		set_imask_ccr(0)
#elif ( CPU_TYPE == SH2 )
static int save_mask;			/* ݂̊荞ݗDl */
//#define INTR_ENABLE()		set_cr(save_cr)
//#define INTR_DISABLE()		save_cr = get_cr(); set_imask(SH_INTR_MASK)
//#define INTR_ENABLE()		set_imask(0)
//#define INTR_DISABLE()		set_imask(SH_INTR_MASK)
#define INTR_DISABLE()		save_mask = get_imask(); set_imask(SH_INTR_MASK)
#define INTR_ENABLE()		set_imask(save_mask)
#endif

/*-----------------------------------------------
/ *STATIC
------------------------------------------------*/
/* tx buffer */
static byte tx_buffer[TX_BUFSIZE];
static volatile byte *tx_rp, *tx_wp;
/* rx buffer */
static byte rx_buffer[RX_BUFSIZE];
static volatile byte *rx_rp, *rx_wp;
/* err */
static volatile byte sci_err;


/*-------------------------------------------------------------------
/ 
/------------------------------------------------------------------*/
void SCI_INIT(void)
{
	tx_rp = tx_wp = &tx_buffer[0];
	rx_rp = rx_wp = &rx_buffer[0];

	SCIx.SCRn.BIT.TIE = 0;
	SCIx.SCRn.BIT.RIE  = 1;
	SCIx.SCRn.BIT.TE   = 1;
	SCIx.SCRn.BIT.RE   = 1;
	SCIx.SCRn.BIT.MPIE = 0;
	SCIx.SCRn.BIT.TEIE = 0;
}
/*-------------------------------------------------------------------
/ PM
/	ENT:
/	  byte data						tx data
/	RET:
/	  int							0:OK
/									!0:NG
/------------------------------------------------------------------*/
int SCI_PUT(byte data)
{
#ifdef TX_SIMPLE				/* simple */
	if(SCIx.SSR.BIT.TDRE == 0){ return 1; }

	SCIx.TDR = data;
	SCIx.SSR.BIT.TDRE = 0;
	return 0;
#else
	bool full;
	byte *wp;

	full = sci_err & TXBUF_FULL;
	if( full ){
		return 1;
	}

	*tx_wp = data;
	wp = tx_wp + 1;
	if(wp == &tx_buffer[TX_BUFSIZE]){
		wp = &tx_buffer[0];
	}
	tx_wp = wp;

	if(tx_wp == tx_rp){
		sci_err |= TXBUF_FULL;
	}
	return 0;

#endif
}
/*-------------------------------------------------------------------
/ MgK
/------------------------------------------------------------------*/
void SCI_TXTRG(void)
{
#ifndef TX_SIMPLE
	INTR_DISABLE();							/* S荞݋֎~ */
	if(tx_wp == tx_rp){
		if( !(sci_err & TXBUF_FULL) ){ goto TRG_END; }
	}
	SCIx.SCRn.BIT.TIE = 1;		/* MJn */
TRG_END:
	INTR_ENABLE();							/* 荞݋ */
#endif
}

/*-------------------------------------------------------------------
/ PM
/	ENT:
/	  int ch						SCI no
/	RET:
/	  int							& 0x100 -> f[^L
/									ʃoCg -> Mf[^
/------------------------------------------------------------------*/
int SCI_GET(void)
{
	bool full;
	int data;
	byte *rp;

	full = sci_err & RXBUF_FULL;

	if( !full ){
		if(rx_rp == rx_wp){ return 0; }
	}

	data = *rx_rp | 0x100;
	rp = rx_rp + 1;
	if(rp == &rx_buffer[RX_BUFSIZE]){
		rp = &rx_buffer[0];
	}
	rx_rp = rp;

	if( full ){
		sci_err &= ~RXBUF_FULL;
		SCIx.SCRn.BIT.RE   = 1;		/* MJn */
	}
	return data;
}
/*-------------------------------------------------------------------
/ M
/	ENT:
/	  byte *buf						Mf[^
/	  int len						Mf[^
/	RET:
/	  int							Mf[^
/------------------------------------------------------------------*/
int SCI_PUTS(const byte *buf, int len)
{
	int max = 0;
	while(len > 0){
		if(SCI_PUT(*buf) != 0){ break; }
		max++;
		len--;
		buf++;
	}
	if(max > 0){ SCI_TXTRG(); }
	return max;
}
/*-------------------------------------------------------------------
/ M
/	ENT:
/	  byte *buf						Mf[^obt@
/	  int max						obt@ő咷
/	RET:
/	  int							Mf[^
/------------------------------------------------------------------*/
int SCI_GETS(byte *buf, int max)
{
	int len = 0;
	int data;
	while(max > 0){
		data = SCI_GET();
		if( !(data & 0x100) ){ break; }		/* f[^ */
		*buf = (byte)data;
		max--;
		len++;
		buf++;
	}
	return len;
}

/*-------------------------------------------------------------------
/ Mobt@󂫃TCY̎擾
/------------------------------------------------------------------*/
int SCI_GETTXFREE(void)
{
	int len;

	if(tx_wp >= tx_rp){
		len = (tx_wp - tx_rp) + TX_BUFSIZE;
	}else{
		len = tx_rp - tx_wp;
	}
	return 0;
}

/*-------------------------------------------------------------------
/ Mobt@󂫃TCY̎擾
/------------------------------------------------------------------*/
int SCI_GETRXFREE(void)
{
	int len;

	if(rx_wp >= rx_rp){
		len = (rx_wp - rx_rp) + RX_BUFSIZE;
	}else{
		len = rx_rp - rx_wp;
	}
	return 0;
}

/*-------------------------------------------------------------------
/ G[̎擾
/------------------------------------------------------------------*/
byte SCI_GETERR(void)
{
#if 0
	return sci_err;
#else																//MOD 002
	byte err;
	INTR_DISABLE();							/* S荞݋֎~ */
	err = sci_err;
//	sci_err &= ~(RXBUF_FULL | TXBUF_FULL);		/* NA */		//MOD 003
	sci_err &= (RXBUF_FULL | TXBUF_FULL);		/* NA */
	INTR_ENABLE();							/* 荞݋ */
	return err;
#endif
}

/*-------------------------------------------------------------------
/ Mobt@NA									ADD 002
/------------------------------------------------------------------*/
void SCI_RXBUFCLEAR(void)
{
	rx_rp = rx_wp;
	if( sci_err & RXBUF_FULL ){
		sci_err &= ~RXBUF_FULL;
		SCIx.SCRn.BIT.RE   = 1;		/* MJn */
	}
}

/*-------------------------------------------------------------------
/ MImF											ADD 002
/------------------------------------------------------------------*/
bool SCI_TXEMPTY(void)
{
//	return !(sci_err & TXBUF_FULL) && (tx_rp == tx_wp);				// MOD 004
	return !(sci_err & TXBUF_FULL) && (tx_rp == tx_wp) && (SCIx.SSR.BIT.TEND == 1);
}

#pragma section IntPRG
/*-------------------------------------------------------------------
/ MG[荞
/------------------------------------------------------------------*/
INT_ERI(void)
{
	if(SCIx.SSR.BIT.FER == 1){
		sci_err |= FRAMING_ERROR;									//ADD 002
		SCIx.SSR.BIT.FER = 0;
	}
	if(SCIx.SSR.BIT.PER == 1){
		sci_err |= PARITY_ERROR;									//ADD 002
		SCIx.SSR.BIT.PER = 0;
	}
	if(SCIx.SSR.BIT.OERx == 1){
		sci_err |= OVERRUN_ERROR;									//ADD 002
		SCIx.SSR.BIT.OERx = 0;
	}
}
/*-------------------------------------------------------------------
/ M荞
/------------------------------------------------------------------*/
INT_RXI(void)
{
	if(SCIx.SSR.BIT.RDRF == 1){
		*rx_wp = SCIx.RDR;
#if 0
		if(++rx_wp == &rx_buffer[RX_BUFSIZE]){
			rx_wp = &rx_buffer[0];
			if(rx_wp == rx_rp){
				sci_err |= RXBUF_FULL;
				SCIx.SCRn.BIT.RE   = 0;		/* M~ */
			}
		}
#else																//MOD 006
		if(++rx_wp == &rx_buffer[RX_BUFSIZE]){
			rx_wp = &rx_buffer[0];
		}
		if(rx_wp == rx_rp){
			sci_err |= RXBUF_FULL;
			SCIx.SCRn.BIT.RE   = 0;		/* M~ */
		}
#endif
//#if ( CPU_TYPE == H8_3069 )										//MOD 002
#if ( CPU_TYPE == H8_3069 ) || ( CPU_TYPE == SH2 )					//MOD 006
		SCIx.SSR.BIT.RDRF = 0;
#endif
	}
}
/*-------------------------------------------------------------------
/ M荞
/------------------------------------------------------------------*/
INT_TXI(void)
{
	if(SCIx.SSR.BIT.TDRE == 1){
		SCIx.TDR = *tx_rp;
		if(++tx_rp == &tx_buffer[TX_BUFSIZE]){
			tx_rp = &tx_buffer[0];
		}
		if(tx_rp == tx_wp){		/* empty */
//			SCIx.SCRn.BIT.TE   = 0;		/* M~ */
			SCIx.SCRn.BIT.TIE   = 0;		/* M~ */
		}
		sci_err &= ~TXBUF_FULL;
//#if ( CPU_TYPE == H8_3069 )										//MOD 002
#if ( CPU_TYPE == H8_3069 ) || ( CPU_TYPE == SH2 )					//MOD 006
		SCIx.SSR.BIT.TDRE = 0;
#endif
	}
}
