/*----------------------------------------------------------------------------
/ SCI
/---------------------------------------------------------------------------*/
#ifndef __SCI_H_
#define __SCI_H_

#include "lp.h"

/*-----------------------------------------------
/ *DEFINE
/----------------------------------------------*/
/* err info */
#define TXBUF_FULL		0x10
#define RXBUF_FULL		0x01
#define FRAMING_ERROR	0x02										//ADD 002
#define PARITY_ERROR	0x04										//ADD 002
#define OVERRUN_ERROR	0x08										//ADD 002

/*-----------------------------------------------
/ *EXTERN
/----------------------------------------------*/

/*-----------------------------------------------
/ *PROTOTYPE
/----------------------------------------------*/
/* SCI0 */
void sci0_init(void);
int sci0_put(byte data);
void sci0_txtrg(void);
int sci0_get(void);
int sci0_puts(const byte *buf, int len);
int sci0_gets(byte *buf, int max);
int sci0_gettxfree(void);
int sci0_getrxfree(void);
byte sci0_geterr(void);
void sci0_rxbufclear(void);											//ADD 002
//bool sci0_txempy(void);											//ADD 004	// MOD 003
bool sci0_txempty(void);
void sci0_intr_er(void);
void sci0_intr_rx(void);
void sci0_intr_tx(void);

/* SCI1 */
void sci1_init(void);
int sci1_put(byte data);
void sci1_txtrg(void);
int sci1_get(void);
int sci1_puts(const byte *buf, int len);
int sci1_gets(byte *buf, int max);
int sci1_gettxfree(void);
int sci1_getrxfree(void);
byte sci1_geterr(void);
void sci1_rxbufclear(void);											//ADD 002
//bool sci1_txempy(void);											//ADD 002
bool sci1_txempty(void);											//ADD 002	// MOD 003
void sci1_intr_er(void);
void sci1_intr_rx(void);
void sci1_intr_tx(void);

/* SCI2 */
void sci2_init(void);
int sci2_put(byte data);
void sci2_txtrg(void);
int sci2_get(void);
int sci2_puts(const byte *buf, int len);
int sci2_gets(byte *buf, int max);
int sci2_gettxfree(void);
int sci2_getrxfree(void);
byte sci2_geterr(void);
void sci2_rxbufclear(void);											//ADD 002
//bool sci2_txempy(void);												//ADD 002
bool sci2_txempty(void);												//ADD 002	// MOD 003
void sci2_intr_er(void);
void sci2_intr_rx(void);
void sci2_intr_tx(void);

/* SCI3 */
void sci3_init(void);
int sci3_put(byte data);
void sci3_txtrg(void);
int sci3_get(void);
int sci3_puts(const byte *buf, int len);
int sci3_gets(byte *buf, int max);
int sci3_gettxfree(void);
int sci3_getrxfree(void);
byte sci3_geterr(void);
void sci3_rxbufclear(void);											//ADD 002
//bool sci3_txempy(void);											//ADD 002 //MOD 003
bool sci3_txempty(void);
void sci3_intr_er(void);
void sci3_intr_rx(void);
void sci3_intr_tx(void);

/* SCI3_2 */
void sci32_init(void);
int sci32_put(byte data);
void sci32_txtrg(void);
int sci32_get(void);
int sci32_puts(const byte *buf, int len);
int sci32_gets(byte *buf, int max);
int sci32_gettxfree(void);
int sci32_getrxfree(void);
byte sci32_geterr(void);
void sci32_rxbufclear(void);										//ADD 002
bool sci32_txempty(void);											//ADD 002
void sci32_intr_er(void);
void sci32_intr_rx(void);
void sci32_intr_tx(void);

#endif
